﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace MergeByDefect
{
    //class used to handle calls to Patch.exe
    class Patch
    {
        private string patchLocation;
        private string workDir;
        public Patch()
        {
            patchLocation = GlobaVars.patchLocation;
            workDir = GlobaVars.workDir;
        }
        
        public string CallPatch(string patchCommand)
        {
            string patchResult = "";
            Process patch = new Process();
            patch.EnableRaisingEvents = false;
            patch.StartInfo.UseShellExecute = false;
            patch.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
            patch.StartInfo.FileName = "\"" + patchLocation + "\"";
            patch.StartInfo.Arguments = patchCommand;
            patch.StartInfo.RedirectStandardOutput = true;
            patch.StartInfo.RedirectStandardInput = false;
            bool returnCode = patch.Start();
            
            string patchResults = patch.StandardOutput.ReadToEnd();
            if(patchResults.Contains("patch detected"))
            {
                patchResult += "\nPreviously applied patch detected! Skipping merge.";
                Logger.WriteLine("\nPreviously applied patch detected! Skipping merge.");
            }
            if (patchResults.Equals(""))
            {
                patchResult += "\nNo Merge Detected.\nThe selected version might not be\ndifferent than the previous version";
                Logger.WriteLine("\nNo Merge Detected.\nThe selected version might not be\ndifferent than the previous version");
            }
            if (!returnCode)
            {
                patchResult += "\r\nError: " + patchResults;
                Logger.WriteLine("\r\nError: " + patchResults);
            }
            if (patchResults.Contains("FAILED"))
            {
                patchResult += "\r\nMerge Failed: " + patchResults;
                Logger.WriteLine("\r\nMerge Failed: " + patchResults);
            }
            patch.WaitForExit();
            return patchResult;
        }
        public string sscmApplyPatch(string fileToPatch)
        {
            string result = "";
            string strCLI = "-u";
            strCLI += " -t -N"; //added the -N which prevents double merges
            strCLI += " \"" + fileToPatch + "\"";
            strCLI += " \"" + workDir + "patch.txt\"";
            result = CallPatch(strCLI);
            Logger.WriteLine("\r\nApplying patch to file...");
            return result;
        }

    }
}
