﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MergeByDefect
{
    //Class that includes all calls to the Surround SCM CLI
    class SSCM
    {   
        public void callSSCM(string p_scmCmd)
        {
            Process sscm = new Process();
            //  sscm.EnableRaisingEvents = false;
            sscm.StartInfo.UseShellExecute = false;
            sscm.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
            sscm.StartInfo.FileName = "\"" + GlobaVars.scmLocation + "\"";
            sscm.StartInfo.Arguments = p_scmCmd;
            sscm.StartInfo.RedirectStandardOutput = true;
            // sscm.StartInfo.RedirectStandardInput = false;   
            sscm.StartInfo.CreateNoWindow = true;
            bool returnCode = sscm.Start();

            String sscmResults = sscm.StandardOutput.ReadToEnd();
            sscm.WaitForExit();
            int result = sscm.ExitCode;
            if (sscmResults.Contains("error: ") || !returnCode)
            {
                Logger.WriteLine("\r\nError: " + sscmResults);
            }
        }
        public void getDifferences(int fileVersion)
        {
                
                string strCLI = "dr";
                strCLI += " \"" + GlobaVars.scmFile + "\"";
                strCLI += " -b\"" + GlobaVars.scmSrcBranch + "\"";
                strCLI += " -p\"" + GlobaVars.scmRepository + "\"";
                strCLI += " -o\"" + GlobaVars.workDir + "patch.txt\"";
                strCLI += " -v\"" + fileVersion.ToString() + "\"";
                strCLI += " -y\"" + GlobaVars.scmUser + ":" + GlobaVars.scmPassword + "\"";
                strCLI += " -z\"" + GlobaVars.scmServer + ":" + GlobaVars.scmPort + "\"";
                callSSCM(strCLI);                            
        }
    }
}
