﻿using System;
using System.Collections;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Seapine.SurroundSCM.API;

namespace MergeByDefect
{
    public partial class frmBranchBrowser : Form
    {
        public ImageList newImageList;
        public TreeNode master;
        public ArrayList alBranches = new ArrayList();
        public string mainline;
        public string selBranch;
        SSCMContext context;
        Form main;

        public frmBranchBrowser(Form mainForm)
        {
            InitializeComponent();
            main = mainForm;
            
        }
        private void setImageLIst()
        {
            //Handling the images for the branches
            try
            {

                System.Drawing.Bitmap branch = Properties.Resources.branch;
                newImageList = new ImageList();
                newImageList.Images.Add(branch);

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void frmBranchBrowser_Load(object sender, EventArgs e)
        {
           
            context = new SSCMContext();
            try
            {
                SSCMResult conResult = SSCMAPI.Connect(GlobaVars.scmServer, GlobaVars.scmPort, GlobaVars.scmUser, GlobaVars.scmPassword, out context);
                if (conResult.IsOk())
                {

                    mainline = GlobaVars.scmMainline;
                    context.SetMainline(mainline);
                    context.SetBranch(mainline);
                    TreeNode rootNode = null;
                    CheckChildBranches(mainline);
                    ProcessArray();
                    //rootNode = BuildBranchTree();
                    rootNode = PopulateBranchTree();

                    tvBranches.Nodes.Add(rootNode);
                    SSCMAPI.Disconnect(context);
                    setImageLIst();
                    tvBranches.ImageList = newImageList;
                    tvBranches.ImageIndex = 0;
                }
            }
            catch (Exception fcc)
            {
                SSCMAPI.Disconnect(context);
            }

            
        }
        private void CheckChildBranches(string curBranch)
        {
            if (curBranch == mainline)
            {
                CBranch bMainline = new CBranch();
                bMainline.SetMainline(mainline);
                bMainline.SetName(mainline);
                bMainline.SetLevel("0");
                bMainline.SetPath(mainline);
                bMainline.SetParent("");

                alBranches.Add(bMainline);
            }
            SSCMBranch[] tempRepos = new SSCMBranch[0];
            
            context.SetBranch(curBranch);
            SSCMResult result = SSCMAPI.GetBranches(context, false, out tempRepos);
            int count = 0;
            for (int i = 0; i < tempRepos.Length; i++)
            {
                if (tempRepos[i].GetType() == SSCMBranchType.Baseline)
                {
                    count++;
                }
            }
            SSCMBranch[] repos = new SSCMBranch[count];
            int counter = 0;
            for (int i = 0; i < tempRepos.Length; i++)
            {
                if (tempRepos[i].GetType() == SSCMBranchType.Baseline)
                {
                    repos[counter] = new SSCMBranch();
                    repos[counter] = tempRepos[i];
                    counter++;
                }
            }



            if (result.IsOk())
            {
                for (int i = 0; i < repos.Length; i++)
                {
                    CBranch child = new CBranch();
                    child.SetMainline(mainline);
                    child.SetParent(curBranch);
                    child.SetName(repos[i].GetName());
                    child.SetLevel("");
                    alBranches.Add(child);
                    CheckChildBranches(repos[i].GetName());
                }
            }
        }
        private void ProcessArray()
        {
            bool flag = true;
            int counter = 0;

            while (flag)
            {
                string branchPath = mainline;
                for (int i = 0; i < alBranches.Count; i++)
                {
                    CBranch branch = (CBranch)alBranches[i];
                    for (int j = 0; j < alBranches.Count; j++)
                    {
                        CBranch parent = (CBranch)alBranches[j];
                        if (branch.GetParent().Equals(parent.GetName()))
                        {
                            if (parent.GetLevel().Equals(counter.ToString()))
                            {
                                int level = counter + 1;
                                branch.SetLevel(level.ToString());
                                branchPath = parent.GetPath() + "/" + branch.GetName();
                                branch.SetPath(branchPath);
                            }
                        }

                    }

                }
                bool lcontinue = false;
                for (int i = 0; i < alBranches.Count; i++)
                {
                    CBranch branch = (CBranch)alBranches[i];
                    if (branch.GetLevel().Equals(""))
                    {
                        lcontinue = true;
                    }
                }
                if (lcontinue == false)
                {
                    flag = false;
                }

                counter++;

            }
        }
        //Method for populating a branch tree
        public TreeNode PopulateBranchTree()
        {
            //Start with the maineline
            TreeNode root = new TreeNode(mainline);
            //Now we will handle all other repos/nodes
            //Define the nodes we will be using
            TreeNode curNode = null;//node that we are currently on and test for children
            TreeNode addNode = null;//the node to add to the current node
            TreeNode testNode = null;//the node to test to reset the current node
            //Define strings that we will use when parsing out the repo path
            string branchPath = "";
            string branchToCheck = "";//String to use to check against testNode
            //Define ints
            int pos = 0;//position of "/" in repo path
            int nodeCnt = 0;//count of children in curNode
            for (int i = 0; i < alBranches.Count; i++)
            {
                CBranch branch = (CBranch)alBranches[i];
                //We want all branches EXCEPT the root
                if (!(branch.GetLevel().Equals("0")))
                {
                    curNode = root;
                    branchPath = branch.GetPath();
                    //remove the root since that is already added
                    pos = branchPath.IndexOf("/");
                    branchPath = branchPath.Substring(pos + 1);
                    //if remaining path still has "/" we need to process further
                    while (branchPath.Contains("/"))
                    {
                        pos = branchPath.IndexOf("/");
                        branchToCheck = branchPath.Substring(0, pos);
                        branchPath = branchPath.Substring(pos + 1);
                        //we need to get the children of curNode and see which one we need to reset as curNode
                        nodeCnt = curNode.Nodes.Count;
                        for (int j = 0; j < nodeCnt; j++)
                        {
                            testNode = curNode.Nodes[j];
                            if (testNode.Text.Equals(branchToCheck))
                            {
                                curNode = testNode;
                                break;
                            }
                        }
                    }
                    addNode = new TreeNode(branchPath);
                    curNode.Nodes.Add(addNode);
                }
            }
            return root;

        }
        public partial class CBranch
        {

            private string Name;
            private string Path;
            private string Parent;
            private string Level;
            private string Mainline;


            /// <remarks/>
            ///

            public string GetName()
            {
                return this.Name;

            }
            public void SetName(string name)
            {
                this.Name = name;
            }

            public string GetPath()
            {
                return this.Path;

            }
            public void SetPath(string path)
            {
                this.Path = path;
            }

            public string GetParent()
            {
                return this.Parent;

            }
            public void SetParent(string parent)
            {
                this.Parent = parent;

            }
            public string GetLevel()
            {
                return this.Level;

            }
            public void SetLevel(string level)
            {
                this.Level = level;

            }
            public string GetMainline()
            {
                return this.Mainline;

            }
            public void SetMainline(string mainline)
            {
                this.Mainline = mainline;

            }
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            main.Controls["grpMergeInto"].Controls["txtDstBranch"].Text = selBranch;
            this.Close();
        }

        private void tvBranches_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
           
        }

        private void tvBranches_AfterSelect(object sender, TreeViewEventArgs e)
        {
            selBranch = tvBranches.SelectedNode.Text;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
